import random
import os
from scan_manager import ScanManager

# Generic variables
scan_image_list = os.environ.get("SCAN_IMAGE_LIST")
primary_trigger_scan = os.environ.get("PRIMARY_TRIGGER_SCAN", "true").lower()

# cbctl and twistcli variables
primary_workflow_file = "scan.yml"
primary_custom_id = random.randbytes(16).hex()
primary_inputs = inputs = {
    "SCAN_IMAGE_LIST_INPUT": scan_image_list,
    "CUSTOM_ID": primary_custom_id,
}

# BlackDuck variables
blackduck_trigger_scan = os.environ.get("BLACKDUCK_TRIGGER_SCAN", "false").lower()
blackduck_project_group = os.environ.get("BLACKDUCK_PROJECT_GROUP", "CB Cloud (CBC)")
blackduck_project_name = os.environ.get("BLACKDUCK_PROJECT_NAME", "ESG-Product-Security-Test")
blackduck_project_version = os.environ.get("BLACKDUCK_PROJECT_VERSION", "unknown")
blackduck_detect_tools = os.environ.get("BLACKDUCK_DETECT_TOOLS", "BINARY_SCAN,CONTAINER_SCAN")
blackduck_excluded_tools = os.environ.get(
    "BLACKDUCK_EXCLUDED_TOOLS",
    "DETECTOR,SIGNATURE_SCAN,IMPACT_ANALYSIS,DOCKER,BAZEL,IAC_SCAN,THREAT_INTEL",
)
blackduck_custom_id = random.randbytes(16).hex()
blackduck_workflow_file = "blackduck.yml"
blackduck_inputs = {
    "BLACKDUCK_PROJECT_GROUP": blackduck_project_group,
    "BLACKDUCK_PROJECT_NAME": blackduck_project_name,
    "BLACKDUCK_TARGET": scan_image_list,
    "BLACKDUCK_DETECT_TOOLS": blackduck_detect_tools,
    "BLACKDUCK_EXCLUDED_TOOLS": blackduck_excluded_tools,
    "CUSTOM_ID": blackduck_custom_id,
}

if __name__ == "__main__":
    if blackduck_trigger_scan == "true":
        primary_trigger_scan = "false"
        blackduck_scan_manager = ScanManager()

        blackduck_scan_manager.initiate_scan(
            blackduck_workflow_file,
            blackduck_custom_id,
            blackduck_inputs,
        )

    if primary_trigger_scan == "true":
        primary_scan_manager = ScanManager()

        primary_scan_manager.initiate_scan(
            primary_workflow_file,
            primary_custom_id,
            primary_inputs
        )
